]> git.ipfire.org Git - thirdparty/git.git/blob - git-sh-setup.sh
Merge branch 'sp/merge' (early part)
[thirdparty/git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
7
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
13
14 die() {
15 echo >&2 "$@"
16 exit 1
17 }
18
19 usage() {
20 die "Usage: $0 $USAGE"
21 }
22
23 set_reflog_action() {
24 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25 then
26 GIT_REFLOG_ACTION="$*"
27 export GIT_REFLOG_ACTION
28 fi
29 }
30
31 is_bare_repository () {
32 git-repo-config --bool --get core.bare ||
33 case "$GIT_DIR" in
34 .git | */.git) echo false ;;
35 *) echo true ;;
36 esac
37 }
38
39 cd_to_toplevel () {
40 cdup=$(git-rev-parse --show-cdup)
41 if test ! -z "$cdup"
42 then
43 cd "$cdup" || {
44 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
45 exit 1
46 }
47 fi
48 }
49
50 require_work_tree () {
51 test $(is_bare_repository) = false ||
52 die "fatal: $0 cannot be used without a working tree."
53 }
54
55 if [ -z "$LONG_USAGE" ]
56 then
57 LONG_USAGE="Usage: $0 $USAGE"
58 else
59 LONG_USAGE="Usage: $0 $USAGE
60
61 $LONG_USAGE"
62 fi
63
64 case "$1" in
65 -h|--h|--he|--hel|--help)
66 echo "$LONG_USAGE"
67 exit
68 esac
69
70 # Make sure we are in a valid repository of a vintage we understand.
71 if [ -z "$SUBDIRECTORY_OK" ]
72 then
73 : ${GIT_DIR=.git}
74 GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
75 exit=$?
76 echo >&2 "You need to run this command from the toplevel of the working tree."
77 exit $exit
78 }
79 else
80 GIT_DIR=$(git-rev-parse --git-dir) || exit
81 fi
82 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}